proc mditext {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     set clientargs [initmditext $name $parent $args]
     set path [::MDI::slave $name $parent $clientargs]
     puts $path 
     set textpath [mdisetuptext $path $name $parent]
     return $cstruct(path)
}
     #MDI::slave cli2 $master1 -height 450 -width 580 -closecmd simpleasthat2 -title "readme.txt"]]" 
proc initmditext {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
     array set cstruct {
           height   "500"
           width    "400"  
           wrap     "none"  
           }
     set res ""
     set args [string range $args 1 [expr [string length $args]-2]]
     foreach {option val} $args {
             switch -- $option {
                    -file   {set cstruct(file)     $val}
                    -wrap   {set cstruct(file)     $val}
                    -scroll {switch $val {
                                    x       {set cstruct(scroll) $val}
                                    y       {set cstruct(scroll) $val}
                                    both    {set cstruct(scroll) $val}
                                    none    {set cstruct(scroll) $val}
                                    default {set cstruct(scroll) both}
                                    }}
                    default {set res "$res -$option $val"}
                    }
             }
     return $res
}

proc mdisetuptext {path name parent} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct

   puts "text path is <$path>"
   #frame $path     -bd 0
   frame $path.bot -bd 0 
   pack  $path.bot -expand no -fill x -side bottom
   pack  $path -expand yes -fill both
   frame $path.text -bd 0
   pack  $path.text -expand yes -fill both
   text  $path.text.text -wrap none
   scrollbar $path.text.scy -command [subst {$path.text.text yview}]
   pack  $path.text.scy -side right -fill y -expand no
   scrollbar $path.bot.scx -orient horizontal -command [subst {$path.text.text xview}]
   pack $path.bot.scx -fill x -side left -expand yes
   pack  $path.text.text -side left -fill both -expand yes
   $path.text.text con -xscrollcommand [subst {$path.bot.scx set}] -yscrollcommand [subst {$path.text.scy set}]

   update idletasks
   frame $path.bot.rect -bd 3 -relief flat -height [lindex [$path.text.scy con -width] 4] -width [lindex [$path.text.scy con -width] 4]
   pack  $path.bot.rect -side right -fill none -expand no

   if {$cstruct(scroll) != "none"} {
      bind $path.text.text <Configure> [subst {checkscrollbar %W $path}]
      }
   bind $path.text.text <Shift-Insert> "puts cut'n'paste"
   #bind $path.text.text <KeyRelease> [subst {::syntext::checkkeyval %K $path}]
   #bind $path.text.text <KeyPress> [subst {::syntext::checkkeyval %K $path}]

   if {[set fname [$cstruct(file)]] !=""} { 
      if [file exists $fname] {
         set file [open $fname]
         $path.text.text insert end [read $file]
         close $file
         }
      }
   
   return $path.text.text

}

proc checkscrollbar {W path} {
upvar #0 $path.text.text this
#if {$path(scroll)==none } return
update idletasks
if {("[$path.text.scy get]" == "0.0 1.0")&&( "[winfo viewable $path.text.scy]")} {pack forget $path.text.scy $path.bot.rect}
if {("[$path.bot.scx  get]" == "0.0 1.0")&&( "[winfo viewable $path.bot.scx ]")} {pack forget $path.bot}
if {("[$path.text.scy get]" != "0.0 1.0")&&(!"[winfo viewable $path.text.scy]")} {pack $path.text.scy -side right -fill y -expand no -before $path.text.text; pack $path.bot.rect -side right}
if {("[$path.bot.scx  get]" != "0.0 1.0")&&(!"[winfo viewable $path.bot.scx ]")} {pack $path.bot -expand no -fill x -side bottom -before $path.text}
}
proc mdigettextconfig {name parent args} {
     set mstructname ::${parent}::
     set cstructname ::${parent}::${name}
     upvar #0 $cstructname cstruct $mstructname mstruct
#if {$args==""} {
#   set res [foreach var [array names cstruct] ]
#   } else {
}
proc mdisettextconfig {name parent args} {}
