
proc minall {master} {
upvar #0 $master mstruct
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        $mstruct(path) coords $cstruct(id) -1800 0
        }
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        ::MDI::minclient $cli $master
        }
}
proc arrall {master} {
upvar #0 $master mstruct
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        if {$cstruct(status)!="minimized"} continue
        $mstruct(path) coords $cstruct(id) -150 0
        }
#update idletasks
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        if {$cstruct(status)!="minimized"} continue
        set cstruct(minroot) ""
        ::MDI::minclient $cli $master
        }
}
proc resall {master} {
upvar #0 $master mstruct
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        if {$cstruct(status)=="normal"} continue
        ::MDI::normclient $cli $master
        }
}
proc next {master} {
upvar #0 $master mstruct
::MDI::setcurrent [lindex $mstruct(clientlist) [expr [llength $mstruct(clientlist)]-1]] $master
}
proc prev {master} {
upvar #0 $master mstruct
::MDI::setcurrent [lindex $mstruct(clientlist) 1] $master
}

proc closemaster {master} {
upvar #0 $master mstruct
flush stdout
foreach cli $mstruct(clientlist) {
        upvar #0 $master$cli cstruct
        $cstruct(path).system.pclose invoke
        }
if {[llength $mstruct(clientlist)]} {
   return
   } else {
   destroy [winfo toplevel $mstruct(path)]
   unset mstruct
   namespace delete $master
   }
}

proc checkresize {m} {
 upvar #0 $m mstruct
 set ismax ""
 update idletasks
 set newsize "[winfo width $mstruct(path)][winfo height $mstruct(path)]"
 if {$newsize == $mstruct(size)} {
    return
    } else {
    set $mstruct(size) $newsize
    }
 foreach cli $mstruct(clientlist) {
         upvar #0 "$m$cli" curcli
         if {$curcli(status)=="maximized"} {
            set ismax $cli
            break
            }
 }
 if {$ismax!=""} {
    if {$mstruct(menupath)!=""} { 
       $mstruct(path) coords $curcli(id) -5 -22
       $mstruct(path) itemconfigure $curcli(id) -height [expr 24+[winfo height $mstruct(path)]] -width [expr 8+[winfo width $mstruct(path)]]
       } else {
       $mstruct(path) coords $curcli(id) 0 0
       $mstruct(path) itemconfig $curcli(id) -width [winfo width $mstruct(path)] -height [winfo height $mstruct(path)]
       }
 } 

}
